﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace ACM_Smoothing
{
    public partial class Form1 : Form
    {

        private Steema.TeeChart.Styles.Surface surface;
        private Steema.TeeChart.Tools.ChartImage colorGridImage = new Steema.TeeChart.Tools.ChartImage();
        private Steema.TeeChart.Tools.Rotate rotate1;
        double Avarage;
        double[,] data = null;
        double howManyPoints;
        
        public Form1()
        {
            howManyPoints = 30;
            InitializeComponent();
            surface = new Steema.TeeChart.Styles.Surface();
            surface.UseColorRange = false;
            surface.UsePalette = true;
            surface.Pen.Visible = false;
            tChart1.Series.Add(surface);
            tChart1.Tools.Add(colorGridImage);
            surface.Visible = true;           
            ClearSafe();
            ScaleColorGrid(1000, 50);
            showData();                                  
        }


//===========================================================================

        private void showData()
        {
            if (data == null)
            {              
                data = readData(Path.Combine(Environment.CurrentDirectory, @"..\..\testData.csv"));// \testData.csv");
            }
            tChart1.AutoRepaint = false;

            for (int i = 0; i < data.GetUpperBound(0) + 1; i++)
            {
                for (int j = 0; j < data.GetUpperBound(1) + 1; j++)
                {
                    if (double.IsNaN(data[i, j]))
                    {
                        surface.Add(j, Avarage, i, Color.Transparent);
                    }
                    else
                    {
                        surface.Add(j, data[i, j], i);
                    }
                }
            }
            tChart1.AutoRepaint = true;
            tChart1.Refresh();
        }


        private double[,] readData(string path)
        {
            int totalRows = 50, totalColumns = 1000;
            double[,] data = new double[totalRows, totalColumns];

            char[] specialChars = { ',', '\"', '\n', '\r' };
            System.IO.StreamReader reader = new System.IO.StreamReader(path);

            string line = "";
            int i = 0;
            int count = 0;
            double sum = 0;
            while (!reader.EndOfStream)            
            {
                line = reader.ReadLine();
                string[] columns = line.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < totalColumns; j++)
                {
                    data[i, j] = Convert.ToDouble(columns[j]);
                    if (!double.IsNaN(data[i, j]))
                    {
                        count++;
                        sum += data[i, j];
                    }
                }
                i++;
            }
            reader.Close();
            reader.Dispose();
            Avarage = sum / count;
            return data;
        }

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.tChart1 = new Steema.TeeChart.TChart();
            this.surface = new Steema.TeeChart.Styles.Surface();
            this.rotate1 = new Steema.TeeChart.Tools.Rotate();
            this.button3 = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // tChart1
            // 
            // 
            // 
            // 
            this.tChart1.Aspect.Chart3DPercent = 90;
            this.tChart1.Aspect.Elevation = 348;
            this.tChart1.Aspect.ElevationFloat = 348;
            this.tChart1.Aspect.Orthogonal = false;
            this.tChart1.Aspect.Perspective = 62;
            this.tChart1.Aspect.Rotation = 329;
            this.tChart1.Aspect.RotationFloat = 329;
            this.tChart1.Aspect.VertOffset = -20;
            this.tChart1.Aspect.VertOffsetFloat = -20;
            this.tChart1.Aspect.ZOffset = 0;
            this.tChart1.Aspect.Zoom = 66;
            this.tChart1.Aspect.ZoomFloat = 66;
            // 
            // 
            // 
            // 
            // 
            // 
            this.tChart1.Axes.Depth.Visible = true;
            this.tChart1.Dock = System.Windows.Forms.DockStyle.Bottom;
            // 
            // 
            // 
            this.tChart1.Header.Lines = new string[] {
        "tChart1"};
            // 
            // 
            // 
            this.tChart1.Legend.Alignment = Steema.TeeChart.LegendAlignments.Top;
            this.tChart1.Legend.Visible = false;
            this.tChart1.Location = new System.Drawing.Point(0, 30);
            this.tChart1.Name = "tChart1";
            // 
            // 
            // 
            // 
            // 
            // 
            this.tChart1.Panel.Brush.Color = System.Drawing.Color.FromArgb(((int)(((byte)(254)))), ((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(255)))));
            this.tChart1.Series.Add(this.surface);
            this.tChart1.Size = new System.Drawing.Size(797, 500);
            this.tChart1.TabIndex = 2;
            this.tChart1.Tools.Add(this.rotate1);
            // 
            // 
            // 
            // 
            // 
            // 
            // 
            // 
            // 
            this.tChart1.Walls.Back.Brush.Color = System.Drawing.Color.FromArgb(((int)(((byte)(153)))), ((int)(((byte)(192)))), ((int)(((byte)(192)))), ((int)(((byte)(192)))));
            // 
            // 
            // 
            this.tChart1.Walls.Back.Brush.Gradient.Transparency = 40;
            // 
            // 
            // 
            this.tChart1.Walls.Back.Pen.Visible = false;
            // 
            // 
            // 
            // 
            // 
            // 
            this.tChart1.Walls.Bottom.Brush.Color = System.Drawing.Color.FromArgb(((int)(((byte)(153)))), ((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(255)))));
            // 
            // 
            // 
            this.tChart1.Walls.Bottom.Brush.Gradient.Transparency = 40;
            // 
            // 
            // 
            this.tChart1.Walls.Bottom.Pen.Visible = false;
            this.tChart1.Walls.Bottom.Size = 5;
            // 
            // 
            // 
            // 
            // 
            // 
            this.tChart1.Walls.Left.Brush.Color = System.Drawing.Color.FromArgb(((int)(((byte)(153)))), ((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(224)))));
            // 
            // 
            // 
            this.tChart1.Walls.Left.Brush.Gradient.Transparency = 40;
            // 
            // 
            // 
            this.tChart1.Walls.Left.Pen.Visible = false;
            this.tChart1.Walls.Left.Size = 5;
            // 
            // surface
            // 
            // 
            // 
            // 
            this.surface.Brush.Color = System.Drawing.Color.FromArgb(((int)(((byte)(68)))), ((int)(((byte)(102)))), ((int)(((byte)(163)))));
            this.surface.Color = System.Drawing.Color.FromArgb(((int)(((byte)(68)))), ((int)(((byte)(102)))), ((int)(((byte)(163)))));
            this.surface.ColorEach = false;
            // 
            // 
            // 
            // 
            // 
            // 
            this.surface.Marks.Callout.ArrowHead = Steema.TeeChart.Styles.ArrowHeadStyles.None;
            this.surface.Marks.Callout.ArrowHeadSize = 8;
            // 
            // 
            // 
            this.surface.Marks.Callout.Brush.Color = System.Drawing.Color.Black;
            this.surface.Marks.Callout.Distance = 0;
            this.surface.Marks.Callout.Draw3D = false;
            this.surface.Marks.Callout.Length = 10;
            this.surface.Marks.Callout.Style = Steema.TeeChart.Styles.PointerStyles.Rectangle;
            this.surface.Marks.Callout.Visible = false;
            this.surface.NumXValues = 25;
            this.surface.NumZValues = 25;
            this.surface.PaletteMin = 0;
            this.surface.PaletteStep = 0;
            this.surface.PaletteStyle = Steema.TeeChart.Styles.PaletteStyles.Pale;
            this.surface.Title = "surface1";
            // 
            // 
            // 
            this.surface.XValues.DataMember = "X";
            // 
            // 
            // 
            this.surface.YValues.DataMember = "Y";
            // 
            // 
            // 
            this.surface.ZValues.DataMember = "Z";
            // 
            // button3
            // 
            this.button3.Location = new System.Drawing.Point(390, 1);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(127, 23);
            this.button3.TabIndex = 4;
            this.button3.Text = "Smooth";
            this.button3.UseVisualStyleBackColor = true;
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // Form1
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(797, 530);
            this.Controls.Add(this.button3);
            this.Controls.Add(this.tChart1);
            this.Name = "Form1";
            this.Text = "Form1";
            this.ResumeLayout(false);

		}
		#endregion

        private void ClearSafe()
        {
            try
            {
                surface.Clear();
                colorGridImage.Image = null;

                surface.PaletteSteps = 30;
                surface.ClearPalette();
                surface.UseColorRange = false;
                surface.StartColor = Color.Green;
                surface.MidColor = Color.LightGreen;
                surface.EndColor = Color.White;
                surface.UsePalette = true;
                tChart1.Refresh();
                surface.UsePalette = true;
            }
            catch (Exception ex)
            {

            }
        }
        private void ScaleColorGrid(int maxX, int maxY)
        {
            try
            {
                tChart1.AutoRepaint = false;

                Steema.TeeChart.Axis scanAxis = tChart1.Axes.Left;
                scanAxis = tChart1.Axes.Depth;

                scanAxis.Automatic = false;
                scanAxis.Minimum = 1;
                scanAxis.Maximum = maxY + 1;
                scanAxis.Inverted = true;

                tChart1.Axes.Bottom.Automatic = false;
                tChart1.Axes.Bottom.Minimum = 1;
                tChart1.Axes.Bottom.Maximum = maxX + 1;

                tChart1.AutoRepaint = true;
            }
            catch (Exception ex)
            {

            }
        }
        private void changeViewMode(bool mode3D)
        {
            if (tChart1.Zoom.Zoomed)
                tChart1.Zoom.Undo();
            tChart1.Panning.Allow = Steema.TeeChart.ScrollModes.None;
            tChart1.Aspect.View3D = mode3D;

            tChart1.Axes.Bottom.Title.Text = "Bin";
            tChart1.Axes.Bottom.Title.Visible = mode3D;
            tChart1.Axes.Bottom.Labels.Visible = mode3D;

            tChart1.Axes.Depth.Automatic = false;
            tChart1.Axes.Depth.Maximum = 50;
            tChart1.Axes.Depth.Visible = mode3D;
            tChart1.Axes.Depth.Title.Text = "Scan";
            tChart1.Axes.Depth.Title.Visible = mode3D;
            tChart1.Axes.Depth.Labels.Visible = mode3D;
            tChart1.Axes.Depth.Inverted = mode3D;

            tChart1.Axes.Left.Automatic = !mode3D;
            tChart1.Axes.Left.Visible = mode3D;
            tChart1.Axes.Left.Labels.Visible = mode3D;

            tChart1.Axes.Bottom.Labels.Font.Size += 10;
            tChart1.Axes.Bottom.Title.Font.Size += 10;
            tChart1.Axes.Depth.Labels.Font.Size += 10;
            tChart1.Axes.Depth.Title.Font.Size += 10;
            tChart1.Axes.Left.Labels.Font.Size += 10;
            tChart1.Axes.Left.Title.Font.Size += 10;

            tChart1.Panning.Allow = Steema.TeeChart.ScrollModes.None;


            if (mode3D)
            {
                tChart1.Aspect.Chart3DPercent = 90;
                tChart1.Aspect.Elevation = 348;
                tChart1.Aspect.Orthogonal = false;
                tChart1.Aspect.Perspective = 62;
                tChart1.Aspect.Rotation = 329;
                tChart1.Aspect.VertOffset = -20;
                tChart1.Aspect.Zoom = 60;
            }
            else
            {
                tChart1.Aspect.Zoom = 100;
            }

            tChart1.Refresh();
        }
       

        private void button3_Click(object sender, EventArgs e)
        {
            TeeSmoothGrid3D.SmoothGrid3D(surface);
            surface.FillGridIndex();

        }
	}

    public class TeeSmoothGrid3D
    {
        public static void SmoothGrid3D(Steema.TeeChart.Styles.Custom3DGrid Series)
        {
            double tmpX, tmpY, tmpZ;
            int tmpNumX = Series.NumXValues;
            int tmpNumZ = Series.NumZValues;

            Series.BeginUpdate();
            Series.IrregularGrid = true;

            try
            {
                for (int x = 1; x < tmpNumX; ++x)
                {
                    for (int z = 1; z < tmpNumZ; ++z)
                    {
                        if (Series[x, z] != -1 && Series[x + 1, z] != -1 && Series[x, z + 1] != -1)
                        {
                            tmpX = (Series.XValues[Series[x, z]] + Series.XValues[Series[x + 1, z]]) * 0.5;
                            tmpZ = (Series.ZValues[Series[x, z]] + Series.ZValues[Series[x, z + 1]]) * 0.5;

                            tmpY = (Series.YValues[Series[x, z]]
                                + Series.YValues[Series[x + 1, z]]
                                + Series.YValues[Series[x, z]]
                                + Series.YValues[Series[x, z + 1]]) * 0.25;

                            Series.Add(tmpX, tmpY, tmpZ);

                            Series.Add(Series.XValues[Series[x, z]],
                                (Series.YValues[Series[x, z]] + Series.YValues[Series[x, z + 1]]) * 0.5,
                                tmpZ);

                            Series.Add(tmpX,
                                (Series.YValues[Series[x, z]] + Series.YValues[Series[x + 1, z]]) * 0.5,
                                Series.ZValues[Series[x, z]]);
                        }
                    }
                    if (Series[x, tmpNumZ] != -1 && Series[x + 1, tmpNumZ] != -1)
                    {
                        Series.Add((Series.XValues[Series[x, tmpNumZ]] + Series.XValues[Series[x + 1, tmpNumZ]]) * 0.5,
                            (Series.YValues[Series[x, tmpNumZ]] + Series.YValues[Series[x + 1, tmpNumZ]]) * 0.5,
                            Series.ZValues[Series[x, tmpNumZ]]);
                    }
                }

                for (int z = 1; z < tmpNumZ; ++z)
                {
                    if (Series[tmpNumX, z] != -1 && Series[tmpNumX, z + 1] != -1)
                    {
                        Series.Add(Series.XValues[Series[tmpNumX, z]],
                            (Series.YValues[Series[tmpNumX, z]] + Series.YValues[Series[tmpNumX, z + 1]]) * 0.5,
                            (Series.ZValues[Series[tmpNumX, z]] + Series.ZValues[Series[tmpNumX, z + 1]]) * 0.5
                            );
                    }
                }
            }
            catch (Exception ex)
            {

            }

            Series.EndUpdate();
            Series.Repaint();
        }
    }

}

